[Setup]
AppId={{2B2FE19B-197A-4F24-8221-1268D967C6EC}
AppName=MyGodMode
AppVerName=MyGodMode 1.4
AppPublisher=Giorgio Tani
AppPublisherURL=http://www.peazip.org/
AppSupportURL=http://www.peazip.org/peazip-add-ons.html
AppUpdatesURL=http://www.peazip.org/peazip-add-ons.html
CreateAppDir=no
DefaultGroupName=MyGodMode
DisableProgramGroupPage=yes
LicenseFile=copying.txt
InfoBeforeFile=readme.txt
OutputDir=.
OutputBaseFilename=MyGodMode-1.4
SetupIconFile=mygodmode.ico
Compression=lzma
SolidCompression=yes

[Languages]
Name: "english"; MessagesFile: "compiler:Default.isl"

[INI]
Filename: "{app}\MyGodMode.url"; Section: "InternetShortcut"; Key: "URL"; String: "http://www.peazip.org/peazip-add-ons.html"

[Icons]
Name: "{group}\{cm:ProgramOnTheWeb,MyGodMode}"; Filename: "{app}\MyGodMode.url"
Name: "{group}\{cm:UninstallProgram,MyGodMode}"; Filename: "{uninstallexe}"

[UninstallDelete]
Type: files; Name: "{app}\MyGodMode.url"

[CustomMessages]
mygodmode_form_Caption=Create links to GodMode folder
mygodmode_form_Description=Chose where the GodMode folder will show up
mygodmode_form_CheckBoxDesk_Caption0=Create icon on Desktop
mygodmode_form_CheckBoxStart_Caption0=Create link in Start Menu
mygodmode_form_CheckBoxQuickstart_Caption0=Create link in Quick Start toolbar (Vista)
mygodmode_form_CheckBoxContext_Caption0=Create entry in system's Context Menu
mygodmode_form_NewStaticText1_Caption0=For non administrative users the last method is recommended

[Code]

var
  CheckBoxDesk: TCheckBox;
  CheckBoxStart: TCheckBox;
  CheckBoxQuickstart: TCheckBox;
  CheckBoxContext: TCheckBox;
  NewStaticText1: TNewStaticText;

{ mygodmode_form_Activate }

procedure mygodmode_form_Activate(Page: TWizardPage);
begin

end;

{ mygodmode_form_ShouldSkipPage }

function mygodmode_form_ShouldSkipPage(Page: TWizardPage): Boolean;
begin
  Result := False;
end;

{ mygodmode_form_BackButtonClick }

function mygodmode_form_BackButtonClick(Page: TWizardPage): Boolean;
begin
  Result := True;
end;

{ mygodmode_form_NextkButtonClick }

function mygodmode_form_NextButtonClick(Page: TWizardPage): Boolean;
begin
  Result := True;
end;

{ mygodmode_form_CancelButtonClick }

procedure mygodmode_form_CancelButtonClick(Page: TWizardPage; var Cancel, Confirm: Boolean);
begin

end;

{ mygodmode_form_CreatePage }

function mygodmode_form_CreatePage(PreviousPageId: Integer): Integer;
var
  Page: TWizardPage;
begin
  Page := CreateCustomPage(
    PreviousPageId,
    ExpandConstant('{cm:mygodmode_form_Caption}'),
    ExpandConstant('{cm:mygodmode_form_Description}')
  );

{ CheckBoxDesk }
  CheckBoxDesk := TCheckBox.Create(Page);
  with CheckBoxDesk do
  begin
    Parent := Page.Surface;
    Caption := ExpandConstant('{cm:mygodmode_form_CheckBoxDesk_Caption0}');
    Left := ScaleX(16);
    Top := ScaleY(16);
    Width := ScaleX(361);
    Height := ScaleY(17);
    State := cbChecked;
    TabOrder := 0;
  end;

  { CheckBoxStart }
  CheckBoxStart := TCheckBox.Create(Page);
  with CheckBoxStart do
  begin
    Parent := Page.Surface;
    Caption := ExpandConstant('{cm:mygodmode_form_CheckBoxStart_Caption0}');
    Left := ScaleX(16);
    Top := ScaleY(40);
    Width := ScaleX(361);
    Height := ScaleY(17);
    TabOrder := 1;
  end;

  { CheckBoxQuickstart }
  CheckBoxQuickstart := TCheckBox.Create(Page);
  with CheckBoxQuickstart do
  begin
    Parent := Page.Surface;
    Caption := ExpandConstant('{cm:mygodmode_form_CheckBoxQuickstart_Caption0}');
    Left := ScaleX(16);
    Top := ScaleY(64);
    Width := ScaleX(361);
    Height := ScaleY(17);
    TabOrder := 2;
  end;

  { CheckBoxContext }
  CheckBoxContext := TCheckBox.Create(Page);
  with CheckBoxContext do
  begin
    Parent := Page.Surface;
    Caption := ExpandConstant('{cm:mygodmode_form_CheckBoxContext_Caption0}');
    Left := ScaleX(16);
    Top := ScaleY(88);
    Width := ScaleX(361);
    Height := ScaleY(17);
    TabOrder := 3;
  end;
  
  { NewStaticText1 }
  NewStaticText1 := TNewStaticText.Create(Page);
  with NewStaticText1 do
  begin
    Parent := Page.Surface;
    Caption := ExpandConstant('{cm:mygodmode_form_NewStaticText1_Caption0}');
    Left := ScaleX(16);
    Top := ScaleY(208);
    Width := ScaleX(295);
    Height := ScaleY(14);
    TabOrder := 4;
  end;

  with Page do
  begin
    OnActivate := @mygodmode_form_Activate;
    OnShouldSkipPage := @mygodmode_form_ShouldSkipPage;
    OnBackButtonClick := @mygodmode_form_BackButtonClick;
    OnNextButtonClick := @mygodmode_form_NextButtonClick;
    OnCancelButtonClick := @mygodmode_form_CancelButtonClick;
  end;

  Result := Page.ID;
end;

{ mygodmode_form_InitializeWizard }

procedure InitializeWizard();
begin
  mygodmode_form_CreatePage(wpSelectDir);//wpWelcome);
end;

procedure clearlinks;
begin
deletefile(ExpandConstant('{group}\GodMode.lnk'));
deletefile(ExpandConstant('{userdesktop}\GodMode.lnk'));
deletefile(ExpandConstant('{userstartmenu}\GodMode.lnk'));
deletefile(ExpandConstant('{userappdata}\Microsoft\Internet Explorer\Quick Launch\GodMode.lnk'));
end;

procedure clearcontextlegacy;
begin
RegDeleteKeyIncludingSubkeys(HKCR, '*\shell\GodMode');
RegDeleteKeyIncludingSubkeys(HKCR, 'Directory\shell\GodMode');
RegDeleteKeyIncludingSubkeys(HKCR, 'Drive\shell\GodMode');
end;

procedure clearcontextseven;
begin
RegDeleteKeyIncludingSubkeys(HKCR, '*\shell\GodMode');
RegDeleteKeyIncludingSubkeys(HKCR, 'Directory\shell\GodMode');
RegDeleteKeyIncludingSubkeys(HKCR, 'Drive\shell\GodMode');
end;

procedure contextlegacy;
begin
RegWriteStringValue(HKCR, '*\shell\GodMode\command', '', ExpandConstant('"{win}\explorer.exe"')+'"shell:::{ED7BA470-8E54-465E-825C-99712043E01C}" ""');
RegWriteStringValue(HKCR, 'Directory\shell\GodMode\command', '', ExpandConstant('"{win}\explorer.exe"')+'"shell:::{ED7BA470-8E54-465E-825C-99712043E01C}" ""');
RegWriteStringValue(HKCR, 'Drive\shell\GodMode\command', '', ExpandConstant('"{win}\explorer.exe"')+'"shell:::{ED7BA470-8E54-465E-825C-99712043E01C}" ""');
end;

procedure contextseven;
begin
RegWriteStringValue(HKCR, '*\shell\GodMode\command', '', ExpandConstant('"{win}\explorer.exe"')+'"shell:::{ED7BA470-8E54-465E-825C-99712043E01C}" ""');
RegWriteStringValue(HKCR, 'Directory\shell\GodMode\command', '', ExpandConstant('"{win}\explorer.exe"')+'"shell:::{ED7BA470-8E54-465E-825C-99712043E01C}" ""');
RegWriteStringValue(HKCR, 'Drive\shell\GodMode\command', '', ExpandConstant('"{win}\explorer.exe"')+'"shell:::{ED7BA470-8E54-465E-825C-99712043E01C}" ""');
RegWriteStringValue(HKCR, '*\shell\GodMode', 'Icon', ExpandConstant('"{sys}\shell32.dll",21'));
RegWriteStringValue(HKCR, 'Directory\shell\GodMode', 'Icon', ExpandConstant('"{sys}\shell32.dll",21'));
RegWriteStringValue(HKCR, 'Drive\shell\GodMode', 'Icon', ExpandConstant('"{sys}\shell32.dll",21'));
end;

procedure createlinkgroup;
begin
  CreateShellLink(
  ExpandConstant('{group}\GodMode.lnk'),
  'All tasks - Windows God Mode',
  ExpandConstant('{win}\explorer.exe'),
  'shell:::{ED7BA470-8E54-465E-825C-99712043E01C}',
  '',
  ExpandConstant('{sys}\shell32.dll'),
  21,
  SW_SHOWNORMAL);
end;

procedure createlinkdesk;
begin
  CreateShellLink(
  ExpandConstant('{userdesktop}\GodMode.lnk'),
  'All tasks - Windows God Mode',
  ExpandConstant('{win}\explorer.exe'),
  'shell:::{ED7BA470-8E54-465E-825C-99712043E01C}',
  '',
  ExpandConstant('{sys}\shell32.dll'),
  21,
  SW_SHOWNORMAL);
end;

procedure createlinkstartmenu;
begin
  CreateShellLink(
  ExpandConstant('{userstartmenu}\GodMode.lnk'),
  'All tasks - Windows God Mode',
  ExpandConstant('{win}\explorer.exe'),
  'shell:::{ED7BA470-8E54-465E-825C-99712043E01C}',
  '',
  ExpandConstant('{sys}\shell32.dll'),
  21,
  SW_SHOWNORMAL);
end;

procedure createlinkquickstart;
begin
  CreateShellLink(
  ExpandConstant('{userappdata}\Microsoft\Internet Explorer\Quick Launch\GodMode.lnk'),
  'All tasks - Windows God Mode',
  ExpandConstant('{win}\explorer.exe'),
  'shell:::{ED7BA470-8E54-465E-825C-99712043E01C}',
  '',
  ExpandConstant('{sys}\shell32.dll'),
  21,
  SW_SHOWNORMAL);
end;

function NextButtonClick(CurPageID: Integer): Boolean;
var
  ResultCode: Integer;
begin
if (GetWindowsVersion shr 24 <6) then
   begin
   SuppressibleMsgBox('GodMode is not featured on older MS systems, Windows Vista or more recent system is required.', mbCriticalError, MB_OK, MB_OK);
   Result := False;
   Exit;
   end;
if CurPageID=wpFinished then
   begin
   clearlinks;
   clearcontextlegacy;
   clearcontextseven;
   createlinkgroup;
   if CheckBoxDesk.State=cbChecked then createlinkdesk;
   if CheckBoxStart.State=cbChecked then createlinkstartmenu;
   if CheckBoxQuickstart.State=cbChecked then createlinkquickstart;
   if CheckBoxContext.State=cbChecked then
      if (GetWindowsVersion shr 24 >=6) and ((GetWindowsVersion shr 16) and $FF >=1) then contextseven
      else contextlegacy;
   end;
Result := True;
end;

procedure CurUninstallStepChanged(CurUninstallStep: TUninstallStep);
begin
if CurUninstallStep = usUninstall then
   begin
   clearlinks;
   clearcontextlegacy;
   clearcontextseven;
   end;
end;








